#
# Chat Backend build config
#

stages:
- setup
- validate
- compile
- test
- package
- verify
- site
- deploy

# Define a base for docker steps to be based off of
.docker: &docker
  image: docker:stable
  services:
  - docker:stable-dind
  before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  tags:
  - docker

.setup: &setup
  image: mhart/alpine-node:8
  stage: setup
  variables:
    YARN_CACHE_FOLDER: .yarn-cache/
    YARN_YARN_OFFLINE_MIRROR: .yarn-mirror/
  before_script:
  - apk add --no-cache git
  - mkdir -p .yarn-mirror .yarn-cache
  artifacts:
    name: "$CI_JOB_NAME"
    paths:
    - node_modules/
  cache:
    key: yarn-cache
    paths:
    - .yarn-cache/
    - .yarn-mirror/

.compile: &compile
  image: mhart/alpine-node:8
  stage: compile
  dependencies:
  - setup:dev

.validate: &validate
  image: mhart/alpine-node:8
  stage: validate
  dependencies:
  - setup:dev

.test: &test
  image: mhart/alpine-node:8
  stage: test
  dependencies:
  - setup:dev

.package-docker: &package-docker
  <<: *docker
  stage: package
  image: docker:stable-git
  variables:
    BASE_IMAGE: ${CI_REGISTRY_IMAGE}
    IMAGE_TAG: ${CI_COMMIT_SHA}
  dependencies:
  - setup:prod

.deploy-docker: &deploy-docker
  <<: *docker
  stage: deploy
  variables:
    BASE_IMAGE: ${CI_REGISTRY_IMAGE}
    IMAGE_TAG: ${CI_COMMIT_SHA}
  script:
  - docker pull ${BASE_IMAGE}:${IMAGE_TAG}
  - docker tag ${BASE_IMAGE}:${IMAGE_TAG} ${BASE_IMAGE}:${DEPLOY_TAG}
  - docker push ${BASE_IMAGE}:${DEPLOY_TAG}
  dependencies: []

# Creates an artifact with all dependencies including devDependencies
setup:dev:
  <<: *setup
  script:
  - yarn install

# Creates an artifact with only the prod dependencies excluding devDependencies
setup:prod:
  <<: *setup
  script:
  - yarn install --production=true

#validate:lint:
#  <<: *validate
#  script:
#  - yarn run lint

compile:
  <<: *compile
  script:
  - yarn package
  artifacts:
    name: "$CI_JOB_NAME"
    paths:
    - bin/

#test:
#  <<: *test
#  script:
#  - yarn run test

package:
  <<: *package-docker
  script:
  - docker build -t ${BASE_IMAGE}:${IMAGE_TAG} .
  - docker push ${BASE_IMAGE}:${IMAGE_TAG}
  dependencies: []

deploy:
  <<: *deploy-docker
  variables:
    BASE_IMAGE: ${CI_REGISTRY_IMAGE}
    IMAGE_TAG: ${CI_COMMIT_SHA}
    DEPLOY_TAG: ${CI_COMMIT_REF_SLUG}

##
## Push latest refs for master updates
##

deploy-latest:
  <<: *deploy-docker
  variables:
    BASE_IMAGE: ${CI_REGISTRY_IMAGE}
    IMAGE_TAG: ${CI_COMMIT_SHA}
    DEPLOY_TAG: latest
  only:
  - master
